# Sentence-Representation

这份代码用来做句子表示学习，即学习一个编码器，能够将一个句子编码成一个带有句子语义信息的向量，从而用于下游任务中。

这份代码采用RNN、CNN多种编码器，通过词预测、词排序、句子排序等方法进行学习。

* 任务说明：

> * 词预测：预测一个词是否在句子中，实验发现，用句子向量与词向量点积的无参方式能够有效提高学习效果。
    
> * 词排序：判断一个句子词序是否正常，正样本是正常的句子，负样本是交换句子中两个词的位置的样本，从而迫使
编码器学习句子的正常语序、语序构造方式。
    
> * 句子排序：一个想法是，能够将句子进行有效排序的前提是能够较好的理解句子，因此采用句子排序来训练句子表示。
实验方法是，相邻句子的句向量句子比非相邻句子句向量距离近，这里采用余弦距离。    

* 代码说明：

> * Config\.py：配置文件规定编码器、参数大小、字典大小、大小写敏感、路径、文件等

> * enc\.py：编码器，实现多种编码器，包括RNN、CNN、CRNN、BiFlow、Transformer等，根据Config的编码器设置，定义不同的编码器结构。
enc\.py还实现了变长RNN编码函数，并且实现pooling函数，根据单向或双向RNN、maxpooling或lastpooling对输出进行池化。

> * folder\.py：dataloader打包函数。文件实现了dataset类，主要是为训练构造样本，包括构造词预测、词排序、句子排序等训练样本，由于实验
采用了bookcorpus和umbc两个训练数据（在这次实验中只采用bookcorpus），两种数据的存储格式以及key不同，需要根据index生成合法的数据。

> * logger\.py：打印函数

> * net\.py： 模型文件。定义了句子表示学习的模型，包括embedding、encoder、forward、lossfunction等。

> * preprocess\.py： 预处理文件。包括构造字典、构造有预训练词向量字典、文件转化为LMDB格式等功能。

> * train\.py： 训练文件。

> * utils\.py： 主要是tensorboard相关定义，方便记录训练过程。

> * vocabulary_expansion\.py： 字典拓展函数。对于scratch训练得到的词向量，将glove词向量作为输入，scratch词向量作为输出，训练一个
线性函数。对于未登录词，若其存在glove预训练词向量，便可以根据预训练词向量与线性函数，得到其在模型中的向量表示，降低未登录词的影响。


> * SentEval\/eval\.py 验证下游任务，包括文本分类、语义匹配、图文检索等。

