# Sentence-Representation

This code is to learn the sentence representations, which can embed the sentences into the semantic vectors for the downstream tasks.

The code take advantage of RNN and CNN with the word-order learning task, word prediction task, and the sentence-order learning task.

Tasks:

(1) The word prediction task is to predict the appearance of a word in the sentence, which can effectively guide the model to learn the wording features in the host sentence. 

(2) The word-order learning task is to predict whether the word order of the sentence is reasonable or logical guiding the model to learn the syntactic and semantic features of sentences. 

(3) The sentence-order learning task is to predict the reasonability of the order of the neighbored sentences for the target sentence capturing the global semantics of the contexts for the target sentence. 

The three tasks can be treated as three classification tasks, which can be merged within a decoder in sentence level. 

  
Code:
> * Config.py：the configuration file.

> * enc.py：the autoencoders, including RNN, CNN, CRNN, BiFlow and Transformer with bi-directions and maxpooling.


> * folder.py：the package of dataloader to obtain the training sets.

> * logger.py：printing function.

> * net.py： the model file with the embedding, encoder, forward, lossfunction and so on.

> * preprocess.py： the preprocess functions.

> * train.py： the training function.

> * utils.py： the utils function with tensorboard.

> * vocabulary_expansion.py: the function for the expansive vocabulary.

> * SentEval\/eval.py: evaluation functions including Text Classification, Paraphrase Detection, Semantic Relatedness, Semantic Textual Similarity, and Image-Sentence Ranking.

